/*  $Id: runnable_func.cpp,v 1.3 2003/07/20 22:30:53 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "Core/precomp.h"

#ifndef header_runnable_func
#define header_runnable_func

#include "API/Core/System/thread.h"

class CL_Runnable_Func : public CL_Runnable
{
public:
	CL_Runnable_Func(int (*func)(void*), void* value)
	{
		this->func = func;
		this->value = value;
	}
	
	virtual void run()
	{
		func(value);
	}

private:
	int (*func)(void*);
	void* value;
};

CL_Thread *CL_Thread::create(int (*func)(void*), void* value)
{
	return CL_Thread::create(
		new CL_Runnable_Func(func, value));
}
	
#endif
