/*  $Id: echofilter_generic.cpp,v 1.2 2003/07/20 22:21:27 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#ifdef WIN32
#pragma warning (disable:4786)
#endif

#include "echofilter_generic.h"
#include <memory.h>

CL_EchoFilter::CL_EchoFilter(int buffer_size, int shift_factor)
{
	impl = new CL_EchoFilter_Generic;
	impl->buffer_size = buffer_size;
	impl->shift_factor = shift_factor;
	impl->pos = 0;

	impl->buffer = new int[buffer_size*2];
	memset(impl->buffer, 0, sizeof(int)*buffer_size*2);
}

CL_EchoFilter::~CL_EchoFilter()
{
	delete[] impl->buffer;
	delete impl;
}

void CL_EchoFilter::filter(int *data, int size)
{
	int *buffer = impl->buffer;
	int &pos = impl->pos;
	int &buffer_size = impl->buffer_size;
	int &shift_factor = impl->shift_factor;

	for (int i=0; i<size*2; i++)
	{
		buffer[pos] /= shift_factor;
		buffer[pos] += data[i];
		data[i] = buffer[pos];
		pos++;
		if (pos == buffer_size) pos = 0;
	}
}
