/*  $Id: soundoutput_directsound.h,v 1.2 2003/07/20 22:21:28 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#ifndef header_soundoutput_directsound
#define header_soundoutput_directsound

#include "../soundoutput_generic.h"

class CL_SoundOutput_DirectSound : public CL_SoundOutput_Generic
{
//! Construction:
public:
	CL_SoundOutput_DirectSound(int mixing_frequency);
	
	~CL_SoundOutput_DirectSound();

//! Attributes:
public:
	LPDIRECTSOUND directsound;

	LPDIRECTSOUNDBUFFER soundbuffer;

	int frag_size, buffer_size, bytes_per_sample;

	HANDLE sleep_event;

	LPDIRECTSOUNDNOTIFY notify;
	
	bool has_sound;

//! Operations:
public:
	//: Called when we have no samples to play - and wants to tell the soundcard
	//: about this possible event.
	virtual void silence();

	//: Returns the buffer size used by device (returned as num [stereo] samples).
	virtual int get_fragment_size();

	//: Writes a fragment to the soundcard.
	virtual void write_fragment(short *data);

	//: Waits until output source isn't full anymore.
	virtual void wait();

//! Implementation:
private:
};

#endif
